<?php
/***************************** Version 20220316 ***************************/
// JSON Modifications courtesy of the ever-generous Ken True
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
//--self downloader --
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;
} ?>
<!DOCTYPE html>
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=Edge"/>
  <title>HAniS GOES-17 Animation</title>
  <script type="text/javascript" src="./HAniS/hanis_min.js"> </script>
<?php if (!isset($sector)) { // Load jquery library if needed
echo '<script src="//ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js" type="text/javascript"></script>';
} ?>
</head>
<?php

$doDebug = false; // Default $doDebug to false
$debugText = '';

/************************ Set Test Parameters for Debugging Purposes ********************/
if (isset($_GET['sector'])) {
   $sector = $_GET['sector'];
 }
if (!isset($sector)) {
	$debugText .= '(!isset($sector)): '.(!isset($sector)).'<br/>';
	$standAlone = false; // Displays outside Saratoga template
	$sector = 'psw'; // Default sector type is set here
/*
		"CONUS" is Pacific US
		"FD" is Full Disk
		"pnw" is Pacific Northwest
		"psw" is Pacific Southwest
		"wus" is US West Coast
		"ak" is Alaska
		"hi" is Hawaii
		"tpw" is Tropical Pacific
*/
	$satBand = 'Dust'; // IMPORTAMT!!! Default image type is set here
	$satBandisNumeric = ($satBand!='GEOCOLOR'&&$satBand!='AirMass'&&$satBand!='Sandwich'&&$satBand!='DayCloudPhase'&&$satBand!='NightMicrophysics'&&$satBand!='FireTemperature'&&$satBand!='EXTENT3'&&$satBand!='CONUS'&&$satBand!='Dust')?true:false;
	$satBand = $satBandisNumeric?($satBand<10?('0'.intval($satBand)):$satBand):$satBand;    
//	$autoRefresh = true; // Use Autorefresh? true or false -- Determines whether AutoRefresh even appears
//	$autoRefreshTime = 10; // Number of minutes between autorefreshes.  IMPORTANT: use 2, 3, 4, 5, 6, 8, 10, 15, 20, or 30 ONLY!!!
//	$autoRefreshOff = false; // Begin with Autorefresh Off? true or false -- 'OFF' or 'ON"
	$bgndColor = 'silver'; // Set HAniS Background Color Here
	$btnColor = 'darkslategray'; // Set Button Color here
	$btnTextColor = 'white'; // Set Button Text Color here
	$pauseSeconds = 2; // Pause on last image, in seconds
	$animRate = 25; // Frame Rate of animation: 5 is glacial, 10 is slow, 15 is leisurely, 20 is good, and 50 is fast - set with integer
	$numbImages = 20; // Number of Radar Images to Animate - 3 to around 25
	$smoothingOn = true; // Enable image smoothing - new in HAniS 2.5
	$checkFiles = false; // Check images before adding them to the filename list?
	$addTime = true;  // Add date & time to images
	$restrictWidth = true; // Width restriction is in effect
	$maxWidth = 1205; // Maximum width allowed
	$wideScreen = false;
}
/************************ End Test Parameters for Debugging Purposes ********************/

  if (isset($_GET['satBand'])) {
    $satBand = $_GET['satBand'];
  }
  if (isset($_GET['imageWidth'])) {
    $imageWidth = $_GET['imageWidth'];
  }
  if (isset($_GET['imageHeight'])) {
    $imageHeight = $_GET['imageHeight'];
  }
  if (isset($_GET['standAlone'])) {
    $standAlone = $_GET['standAlone'];
  }
  if (isset($_GET['bgndColor'])) {
    $bgndColor = $_GET['bgndColor'];
  }
  if (isset($_GET['btnColor'])) {
    $btnColor = $_GET['btnColor'];
  }
  if (isset($_GET['btnTextColor'])) {
    $btnTextColor = $_GET['btnTextColor'];
  }
  if (isset($_GET['animRate'])) {
    $animRate = $_GET['animRate'];
  }
  if (isset($_GET['pauseSeconds'])) {
    $pauseSeconds = $_GET['pauseSeconds'];
  }
/*  if (isset($_GET['autoRefresh'])) {
    $autoRefresh = $_GET['autoRefresh'];
  }
*/
  if (isset($_GET['numbImages'])) {
    $numbImages = $_GET['numbImages'];
  }
  if (isset($_GET['smoothingOn'])) {
    $smoothingOn = $_GET['smoothingOn'];
  }
  if (isset($_GET['doDebug'])) {
    $doDebug = $_GET['doDebug'];
		if ($doDebug) $debugText = 'Setting $debug<br/>';
  }
  if (isset($_GET['checkFiles'])) {
    $checkFiles = $_GET['checkFiles'];
  }
  if (isset($_GET['wideScreen'])) {
    $wideScreen = $_GET['wideScreen'];
  }
  if (isset($_GET['addTime'])) {
    $addTime = $_GET['addTime'];
  }
  if (isset($_GET['restrictedWidth'])) {
    $restrictWidth = $_GET['restrictedWidth'];
  }
  if (isset($_GET['maxWidth'])) {
    $maxWidth = $_GET['maxWidth'];
  }

	$sectorTypes = array('standard','FD','CONUS','wus-ak','tpw'); // Pointers to the various possible image dimensions
	if ($sector=='FD') $ourSectorType = $sectorTypes[1]; // Logic to select our array of dimensions
	else if ($sector=='CONUS') $ourSectorType = $sectorTypes[2];
	else if ($sector=='wus'||$sector=='ak') $ourSectorType = $sectorTypes[3];
	else if ($sector=='tpw') $ourSectorType = $sectorTypes[4];
	else $ourSectorType = $sectorTypes[0];

	$satBandSectors = array( // Array of arrays of possible image dimensions
		'standard'=>array( // The US Regional Image Dimensions
			'widthA'=>1200,
			'iframeWidthA'=>1242,
			'heightA'=>1200,
			'iframeHeightA'=>1295,
			'widthB'=>600,
			'iframeWidthB'=>642,
			'heightB'=>600,
			'iframeHeightB'=>658),
		'FD'=>array( // The Full Disk Dimensions
			'widthA'=>678,
			'iframeWidthA'=>678,
			'heightA'=>678,
			'iframeHeightA'=>733,
			'widthB'=>339,
			'iframeWidthB'=>339,
			'heightB'=>339,
			'iframeHeightB'=>440),
		'CONUS'=>array( // The Continental US Image Dimensions
			'widthA'=>1250,
			'iframeWidthA'=>1292,
			'heightA'=>750,
			'iframeHeightA'=>825,
			'widthB'=>625,
			'iframeWidthB'=>667,
			'heightB'=>375,
			'iframeHeightB'=>450),
		'wus-ak'=>array( // Western US and Alaska Image Dimensions
			'widthA'=>1000,
			'iframeWidthA'=>1042,
			'heightA'=>1000,
			'iframeHeightA'=>1075,
			'widthB'=>500,
			'iframeWidthB'=>542,
			'heightB'=>500,
			'iframeHeightB'=>575),
		'tpw'=>array( // The Tropical Pacific - Wide Dimensions
			'widthA'=>900,
			'iframeWidthA'=>942,
			'heightA'=>540,
			'iframeHeightA'=>615,
			'widthB'=>450,
			'iframeWidthB'=>492,
			'heightB'=>270,
			'iframeHeightB'=>345)
		);
	/* Debug Code *
	if ($doDebug) {
		var_dump($satBandSectors);
		var_dump($satBandSectors['standard']['iframeHeightB']);
		foreach ($satBandSectors as $key1=>$value1) {
		foreach ($value1 as $key=>$value)
			echo '$key1: '.$key1.'=> '.$key.': '.$value.'<br/>';
		}
		echo '$ourSectorType: '.$ourSectorType.'<br/>';
		var_dump($satBandSectors[$ourSectorType]['iframeHeightB']);
//		exit;
	}
	/* End Debug Code */
	$imageWidth = $satBandSectors[$ourSectorType][($wideScreen||$standAlone)?'widthA':'widthB'];
	$iframeWidth = $satBandSectors[$ourSectorType][($wideScreen||$standAlone)?'iframeWidthA':'iframeWidthB'];
	$imageHeight = $satBandSectors[$ourSectorType][($wideScreen||$standAlone)?'heightA':'heightB'];
	$iframeHeight = $satBandSectors[$ourSectorType][($wideScreen||$standAlone)?'iframeHeightA':'iframeHeightB'];
	$iframeHeight += $addTime?20:0;
	$ratioAdjust = 1;
	if (($iframeWidth>$maxWidth)&&$restrictWidth&&($standAlone||$wideScreen)) {
		$ratioAdjust = $maxWidth/$iframeWidth;
		$iframeWidth = ceil($iframeWidth*$ratioAdjust);
		$iframeHeight = ceil($iframeHeight*$ratioAdjust);
	}
/* Debug Code */
	if ($doDebug) {
		$debugText .= '$satBand: '.$satBand.', $sector: '.$sector.', $ourSectorType: '.$ourSectorType.'<br/>';
		$debugText .= '$imageWidth: '.$imageWidth.', $iframeWidth: '.$iframeWidth.', $imageHeight: '.$imageHeight.', $iframeHeight: '.$iframeHeight.'<br/>';
//		exit;
	}
/* End Debug Code */	


?>
	<?php if ($doDebug){
		$debugText .= '$standAlone: '.($standAlone==1?'true':'false').', width: '.$imageWidth.'<br/>Starting \'handiv\' declaration<br/>';
	}
	$fileNameList = '';
	$fileTimes = '';
	get_file_names($sector,', ',$imageWidth,$imageHeight);
	if ($doDebug) $debugText .= '<br/>Raw FilenameList:<br/>'.$fileNameList.'<br/>';
	$fileNames = $fileNameList.' ';
	if ($doDebug) {
		$debugText .= '<br/>Filenames:<br/>'.$fileNames.'<br/>';
		$debugText .= 'Filetimes: '.$fileTimes.'<br/>';
	}
	if ($fileNames=='Satellite Images Currently Unavailable!'||$fileNames=='Too Many Images Requested') {
		print ('<br/>'.$fileNames.'<br/>');
		exit;
	}
?>
  <!-- div style="border: 1px black solid;width:<?php echo $imageWidth?>px;">
<?php
	print '$satBand: '.$satBand.', $sector: '.$sector.', $ourSectorType: '.$ourSectorType."<br/>\n";
	print '$imageWidth: '.$imageWidth.', $imageHeight: '.$imageHeight.', $iframeWidth: '.$iframeWidth.', $iframeHeight: '.$iframeHeight." <br/>\n";

	print "JSONfilename='$JSONfilename'<br/>\n"; 
	print "rawJSONsize=$rawJSONsize, error='$JSONerrorMessage'<br/>\n";
	print "jImageBase='$jImageBase'<br/>\n";
	print "jFilenames='" . join(', ',$jFilenames) . "'<br/>\n";

?></div -->
  <body style="width:<?php echo $imageWidth?>px;" onload="HAniS.setup(
'image_base = <?php print $image_base; ?> \n\
filenames = <?php print $fileNames ?> \n\
controls_style = background-color:<?php echo $bgndColor?>; \n\
controls = startstop, speed, <?php echo $imageWidth<=350?'/':''?>step, looprock, zoom <?php #echo $autoRefresh?', refresh':''?> \n\
speed_labels = Slower, Faster \n\
rate = <?php echo $animRate?> \n\
pause = <?php echo ($pauseSeconds*1000)?> \n\
debug = <?php echo ($doDebug?'true':'false'); ?> \n\
start_looping = true \n\
skip_missing = 0 \n\
skip_missing_color = #800000 \n\
enable_smoothing = <?php echo ($smoothingOn?'t':'f')?> \n\
background_static = n \n\
buttons_style = flex:auto;margin:2px;background-color:<?php echo $btnColor?>;border-radius:7px;color:<?php echo $btnTextColor?>; \n\
bottom_controls = toggle<?php echo $addTime?', /framelabel':''?> \n\
setframelabel_style=font-family:Verdana;font-size:12px;font-weight:bold;color:<?php echo $btnTextColor?>;font-size:14px;padding:2px;background-color:<?php echo $btnColor?>; \n\
framelabel_style=width:180px;height:20px; \n\
frame_labels = <?php echo $addTime?(' '.$fileTimes.' '):'' ?> \n\
toggle_colors = <?php echo $btnColor?>, red, orange \n\
bottom_controls_tooltip = Toggle Labels on/off \n\
bottom_controls_style = background-color:<?php echo $bgndColor?>;' ,
'handiv')">
	<?php if ($doDebug) $debugText .= 'Starting \'handiv\'<br/>';?>
  <div id="handiv" style="width:<?php echo $imageWidth?>px;background-color:#808080; alignment-adjust:central" class="center" align="center">
  </div>
  <?php if ($doDebug) $debugText .= 'Ending \'handiv\'<br/>';?>
  <?php if ($doDebug) {
		print $debugText;
	} ?>

  </body>
  
 </html>
<?php
############## functions ##############
// ------------------------------------------------------------------

function get_file_names($theSector,$separator,$image_Width,$image_Height) {

	date_default_timezone_set("America/Chicago");
	global $numbImages;
	global $satBand;
	global $doDebug;
	global $debugText;
	global $checkFiles;
	global $minuteSet;
	global $addTime,$fileTimes;
	global $fileNameList;
	global $image_base;
	global $JSONfilename;
	global $rawJSONsize;
	global $JSONerrorMessage;
	global $jImageBase,$jFilenames;
	$ourFile = array();
	$matches = array();
	
	$fileNameList = '';
	$fileTimes = '';
	$doFileDebug = false;
 
# use JSON for the image filename list
	$JSONfilename = get_JSON_filename($theSector,$satBand);
	
	$raw = get_data($JSONfilename);
	list($header,$rawJSON) = explode("\r\n\r\n",$raw);
	$rawJSONsize = strlen($rawJSON);
	if($rawJSONsize > 100) {
		list($jImageBase,$jFilenames,$JSONerrorMessage) = 
		   decode_GOES_json($rawJSON,$image_Width,$image_Height,$numbImages);
	} else {
		list($jImageBase,$jFilenames,$JSONerrorMessage) = array('',array(),'');
	}
# end- use JSON for images filename list

  $imageNumber = count($jFilenames);  
	if ($imageNumber<$numbImages) {
    if ( $imageNumber==0) {
			$fileNameList = 'Satellite Images Currently Unavailable!';
  		return ;
		} else if ($imageNumber<$numbImages) {
			$fileNameList = 'Too Many Images Requested';
			return;
		}
	} else {
  	$imageFile = array();

    $imageFile = $jFilenames;
		$image_base = $jImageBase;
		
	  for ($i=0; $i<$numbImages; $i++) { # changed to start at 0
		  $image = $imageFile[$i].($i<($numbImages-1)?$separator:' ');
			$timeString = substr($imageFile[$i],0,11);
			$ourYear = substr($timeString,0,4);
			$dayofYear = (substr($timeString,4,3));
			$minutes = substr($timeString,7,2);
			$seconds = substr($timeString,9,2);
			$date2epoch =mktime(0, 0, 0, 1, 1, $ourYear); // Find the seconds from 1/1/1970 to the current year
			if ($doDebug) {
				$debugText .= '$date2epoch: '.$date2epoch.'<br/>';
			} // The PHP Day of the year is one less than the nesdis.noaa day of year - PHP begins with day 0, nesdis.noaa begins with day 1
			$imageTime = $date2epoch+(($dayofYear-1)*86400)+($minutes*60)+$seconds; // Add the year + the day of the year + minutes + seconds
			$ourDayMonth = date("M_j,",$imageTime);
			$hourMinute = substr($timeString,7,4);
			if ($doDebug) {
				$debugText.= '$timeString: '.$timeString.', $imageTime: '.$imageTime.', $ourYear: '.$ourYear.', $ourDayMonth: '.$ourDayMonth.', $hourMinute: '.$hourMinute.'<br/>';
				$debugText .= 'date("M j, Y",$imageTime): '.date("M j, Y",$imageTime).'<br/>';
			}
			$fileTimes .= ($addTime?(date("j M Y",$imageTime).' '.$hourMinute.' Zulu,'):'');
		  $fileNameList .= $image;
			if ($doDebug) {
				$debugText .= $image;
			}
	  } 
  }
}
/* end get_file_names */
// ------------------------------------------------------------------
/* Begin Function get_data */
function get_data($url)
{
  $ch = curl_init();
  $timeout = 5;
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);                 // don't verify peer certificate
  curl_setopt($ch, CURLOPT_TIMEOUT, 8);                        //  data timeout
  curl_setopt($ch, CURLOPT_NOBODY, false);                     // set nobody
  curl_setopt($ch, CURLOPT_HEADER, true);                      // include header information
  curl_setopt($ch, CURLOPT_USERAGENT,'Mozilla/5.0 (US Satellites/1.1, www.gwwilkins.org)');
  curl_setopt($ch,CURLOPT_URL,$url);
  curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
  curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,$timeout);
  $data = curl_exec($ch);
  curl_close($ch);
  return $data;
}
/* End Function get_data */
// ------------------------------------------------------------------
function checkExternalFile($url)
{
	global $doDebug;
	global $debugText;
  $ch = curl_init($url);
  curl_setopt($ch, CURLOPT_NOBODY, true);
	curl_setopt($ch, CURLOPT_FAILONERROR,true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER ,true);    // catch output (do NOT print!)
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 20);
	$response = curl_exec($ch);
	$badCURL = curl_error($ch);
  $retCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
	if ($doDebug) {
		print curl_error($ch);
		$debugText .= '$CURL: '.($badCURL?$badCURL:'good').', $response: '.($response!==false?'true':'false').', $retCode: '.$retCode.'-File '.($retCode==200?'exists':'is absent').'<br/>';
	}
  curl_close($ch);
		
  return $retCode;
}
// ------------------------------------------------------------------
/* Begin get_JSON_filename  */

function get_JSON_filename($theSector,$satBand) {
	# code by K. True - saratoga-weather.org 
	# produce the JSON filename to use based on the sector and band
	#
	$JF = 'https://cdn.star.nesdis.noaa.gov/GOES17/catalogs/GOES17/'; /* base for GOES17 JSON files. */

	if($theSector == 'CONUS') {
		$JF .= 'CONUS_'.(string)$satBand.'_catalog.json';
	} elseif($theSector == 'FD') {
		$JF .= 'FD_'.(string)$satBand.'_catalog.json';
	} else {
		$JF .= 'SECTOR_'.(string)$satBand.'_'.(string)$theSector.'_catalog.json';
	}
	return($JF);
	
} // end get_JSON_filename

// ------------------------------------------------------------------
/* Begin decode_GOES_json  */

function decode_GOES_json($rawJSON,$width,$height,$numImages) {
	# code by K. True - saratoga-weather.org 
	# decode the JSON data for base URL and array of last numImages available
	#

	$tImageBase = '';
	$tFilenames = array();
	
	$JSON = json_decode($rawJSON,true); // decode to array, not object
  $tError = json_last_error_msg();
	
	if(!isset($JSON['meta']['location']['folder'])) {
		return(array($tImageBase,$tFilenames,$tError .' and no meta in JSON')); // empty return as not the JSON we want
	} else {
		$tImageBase = $JSON['meta']['location']['folder']; // base URL for images
	}
	
	if(isset($JSON['images'][$width.'x'.$height][0]) ) {
		// got images.
		$tArray = $JSON['images'][$width.'x'.$height];
		$tFilenames = array_slice($tArray,-$numImages);
	}
	
	return(array($tImageBase,$tFilenames,$tError));
	
} // end decode_GOES_json

// ------------------------------------------------------------------
/* Begin rfile_exists - In Reserve - Not Currently Used */
function rfile_exists($address)
{
	global $doDebug;
	global $debugText;
	$ch = curl_init();

	curl_setopt($ch,CURLOPT_URL,$address);
	curl_setopt($ch,CURLOPT_NOBODY,1);
	curl_setopt($ch,CURLOPT_FAILONERROR,1);
	curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
	$fileExists = curl_exec($ch);
	if ($doDebug) {
		$debugText .= '$fileExists-r: '.($fileExists?'absent':'exists').'<br/>';
	}
	if($fileExists !== FALSE) {
	curl_close($ch);
	return true;
	}
	curl_close($ch);
	return false;

}
/* End rfile_exists */
// ------------------------------------------------------------------
?>